//
//  ViewController.swift
//  TaiJi
//
//  Created by apple on 17/1/20.
//  Copyright © 2017年 Cynic. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    var shapeLayer = CAShapeLayer()
    let cx_wid = UIScreen.main.bounds.size.width
    let cx_hit = UIScreen.main.bounds.size.height
    var rotateView = UIView.init()
    var timmer = 0
    
    override func viewDidLoad() {
        super.viewDidLoad()
//        self.viewLoad()
    }
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        if timmer == 0 {
        self.viewLoad()
        }
    }
    
    func viewLoad() {
        timmer = 1
        rotateView = UIView.init(frame: UIScreen.main.bounds)
        view.addSubview(rotateView)
        shapeLayer = CAShapeLayer()
        let path = UIBezierPath.init()
        path.addArc(withCenter: CGPoint.init(x: cx_wid / 2, y: cx_hit / 2), radius: cx_wid / 4, startAngle: 0, endAngle: CGFloat(M_PI) * 2, clockwise: true)
        path.addArc(withCenter: CGPoint.init(x: cx_wid / 8 * 5, y: cx_hit / 2), radius: cx_wid / 8, startAngle: 0, endAngle: CGFloat(-M_PI), clockwise: false)
        path.addArc(withCenter: CGPoint.init(x: cx_wid / 8 * 3, y: cx_hit / 2), radius: cx_wid / 8, startAngle: 0, endAngle: CGFloat(M_PI), clockwise: true)
        var center = CGPoint.init(x: 0, y: 0)
        for i in 0...1 {
            if i == 0 {
                center = CGPoint.init(x: cx_wid / 8 * 5, y: cx_hit / 2)
            }
            else{
                center = CGPoint.init(x: cx_wid / 8 * 3, y: cx_hit / 2)
            }
            path.move(to: CGPoint.init(x: center.x + 10, y: center.y))
            path.addArc(withCenter: center, radius: 10, startAngle: 0, endAngle: CGFloat(M_PI) * 2, clockwise: true)
        }
        shapeLayer.path = path.cgPath
        shapeLayer.fillColor = UIColor.clear.cgColor
        shapeLayer.strokeColor = UIColor.black.cgColor
        shapeLayer.lineWidth = 2
        rotateView.layer.addSublayer(shapeLayer)
        self.animation(layer: shapeLayer)
    }
    
    func animation(layer:CAShapeLayer) {
        let show = CABasicAnimation.init(keyPath: "strokeEnd")
        show.duration = 3
        show.fromValue = 0
        show.toValue = 1
        show.timingFunction = CAMediaTimingFunction.init(name: kCAMediaTimingFunctionLinear)
        layer.add(show, forKey: "showAnimation")
        self.roate(layer: layer)
        self.perform(#selector(colorLoad), with: nil, afterDelay: 3)
    }
    
    func roate(layer:CAShapeLayer) {
        UIView.transition(with: self.view, duration: 0.4, options: UIViewAnimationOptions.curveLinear, animations: {
            self.rotateView.transform = self.rotateView.transform.rotated(by: -360)
        }) { (true) in
            self.roate(layer: layer)
        }
//        let roat = CABasicAnimation.init(keyPath: "transform.rotation.z")
//        roat.duration = 0.5
//        roat.fromValue = 0
//        roat.toValue = M_PI * 2
//        roat.timingFunction = CAMediaTimingFunction.init(name: kCAMediaTimingFunctionLinear)
//        roat.repeatCount = 100
//        roat.fillMode = kCAFillModeForwards
//        roat.isRemovedOnCompletion = false
//        layer.add(roat, forKey: "roateNow")
        
    }
    
    func colorLoad() {
        let layerOne = CAShapeLayer.init()
        let layerTwo = CAShapeLayer.init()
        let path1 = UIBezierPath.init()
        let path2 = UIBezierPath.init()
        let center1 = CGPoint.init(x: cx_wid / 8 * 5, y: cx_hit / 2)
        let center2 = CGPoint.init(x: cx_wid / 8 * 3, y: cx_hit / 2)
        path1.move(to: CGPoint.init(x: cx_wid / 4 * 3, y: cx_hit / 2))
        path1.addLine(to: CGPoint.init(x: center1.x + 10, y: center1.y))
        path1.addArc(withCenter: center1, radius: 10, startAngle: 0, endAngle: CGFloat(M_PI) * 2, clockwise: true)
        path1.addLine(to: CGPoint.init(x: cx_wid / 4 * 3, y: cx_hit / 2))
        path1.addArc(withCenter: CGPoint.init(x: cx_wid / 8 * 5, y: cx_hit / 2), radius: cx_wid / 8, startAngle: 0, endAngle: CGFloat(-M_PI), clockwise: false)
        path1.addArc(withCenter: CGPoint.init(x: cx_wid / 8 * 3, y: cx_hit / 2), radius: cx_wid / 8, startAngle: 0, endAngle: CGFloat(M_PI), clockwise: true)
        path1.addArc(withCenter: CGPoint.init(x: cx_wid / 2, y: cx_hit / 2), radius: cx_wid / 4, startAngle: CGFloat(M_PI), endAngle: 0, clockwise: false)
        path2.move(to: CGPoint.init(x: center2.x + 10, y: center2.x))
        path2.addArc(withCenter: center2, radius: 10, startAngle: 0, endAngle: CGFloat(M_PI) * 2, clockwise: true)
        layerOne.path = path1.cgPath
        layerTwo.path = path2.cgPath
        layerTwo.fillColor = UIColor.black.cgColor
        layerOne.fillColor = UIColor.black.cgColor
        layerOne.strokeColor = UIColor.black.cgColor
        rotateView.layer.addSublayer(layerOne)
        rotateView.layer.addSublayer(layerTwo)
        let colorview = UIView.init(frame: UIScreen.main.bounds)
        colorview.backgroundColor = UIColor.black
        rotateView.addSubview(colorview)
        colorview.layer.mask = layerOne
        let animation = CABasicAnimation.init(keyPath: "opacity")
        animation.fromValue = 0
        animation.toValue = 1
        animation.duration = 2
        animation.timingFunction = CAMediaTimingFunction.init(name: kCAMediaTimingFunctionEaseInEaseOut)
        layerOne.add(animation, forKey: "op")
        layerTwo.add(animation, forKey: "op")
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

